#!/usr/bin/env python3

import argparse
import os
import py_wiiu_tik_util

def create_parser():
    parser = argparse.ArgumentParser()
    parser.add_argument("-f","--file",help="ticket file")
    parser.add_argument("-tf","--title-jsonfile",help="json file (like FunkiiU ones) with title data")
    parser.add_argument("--include-ticketdata",help="include ticket data bytes",const=True,nargs="?",default=False)
    parser.add_argument("--add-titlekey",help="add title key from json file",const=True,nargs="?",default=False)
    parser.add_argument("--output-csv",help="output in csv format",nargs="?", const=True, default=None)
    parser.add_argument("--csv-joiner",help="specify csv joiner (default: ;)",default=";")
    return(parser.parse_args())
    
if __name__ == "__main__":
    args = create_parser()
    #print(args)
    
    with py_wiiu_tik_util.WiiUTicketHelper(args.file,args.include_ticketdata,args.title_jsonfile,args.add_titlekey) as tik_help:
        #tik_help.VERBOSE=True
        tik_help.get_all_tickets()
        res = tik_help.return_tickets()
        print(tik_help.fn+":")
    for k,v in res.items():
        if args.output_csv is not None:
            out = [ str(item) for item in v]
            if isinstance(args.output_csv,str): # filename specified
                with open(args.output_csv,"a+") as f:
                    f.write(tik_help.fn+args.csv_joiner+str(k)+args.csv_joiner+args.csv_joiner.join(out)+"\n")
            else:
                print(tik_help.fn+args.csv_joiner+str(k)+args.csv_joiner+args.csv_joiner.join(out))
        else:
            print("ticket-%s: %s" %(k,v))
            
        
            
            
            
